unit plugin;
               // Form plugin demo for Astroart (version 4.0 or later)
interface

uses windows, sysutils, forms;

function pi_initialize(funcaddress:pointer; menuname,description:PAnsiChar;
         whandle: HWND):integer; stdcall;
procedure pi_activate(pimage:pointer; whandle:HWND); stdcall;
procedure pi_finalize(whandle:HWND); stdcall;

type

TAstroartCommand = (ac_getbuffer, ac_getsize, ac_redraw, ac_close, ac_savefits,
  ac_copy, ac_writeheader, ac_readheader, ac_prepareundo, ac_thresholds,
  ac_transferfunc, ac_getselpoint, ac_getselpoint2, ac_gethwnd, ac_create,
  ac_open, ac_getimage, ac_getversion, ac_rename, ac_getname, ac_getra,
  ac_getdec, ac_getx, ac_gety, ac_modified,
  ac_blink, ac_flip, ac_resize, ac_findcoordinates, ac_reserved_1, ac_selectpoint,
  ac_selectrect, ac_reserved_2, ac_reserved_3, ac_reserved_4, ac_centeratlas
);

Tcallbackfunc = function(command:TAstroartCommand; p1,p2,p3:pointer):integer; stdcall;


var
 callback: Tcallbackfunc;

implementation

uses unit1;

(* Commands: see docs

NAME             PARAMS TYPE                   RESULT

ac_getbuffer    (pimage, &buffer, colorplane)  0,2
ac_getsize      (pimage, &x, &y)               0,1
ac_redraw       (pimage, calcstats, autovis)   0,1
ac_close        (pimage, askuser, nil)         0,1
ac_savefits     (pimage, pfilename, nil)       0,1
ac_copy         (pimage, nil, nil)             0,1
ac_writeheader  (pimage, pheader, nil)         0,1
ac_readheader   (pimage, nil, nil)             pheader
ac_prepareundo  (pimage, nil, nil)             0,1
ac_thresholds   (pimage, &min, &max)           0,1
ac_transferfunc (pimage, trf, nil)             0,1
ac_getselpoint  (pimage, &x, &y)               0,1
ac_getselpoint2 (pimage, &x, &y)               0,1
ac_gethwnd      (pimage, &HWND, nil)           0,1
ac_create       (x,y,colored)                  pimage
ac_open         (pfilename, nil, nil)          pimage
ac_getimage     (selection, nil, nil)          pimage

ac_getversion   (nil, nil, nil)                300+
ac_rename       (pimage, name, path)           0,1
ac_getname      (pimage, path, nil)            pfilename
ac_getra        (pimage, x*100, y*100)         ra*1e5
ac_getdec       (pimage, x*100, y*100)         dec*1e5
ac_getx         (pimage, ra*1e6, dec*1e6)      x*100
ac_gety         (pimage, ra*1e6, dec*1e6)      y*100
ac_modified     (pimage, modified, nil)        0,1

ac_blink        (NULL, NULL, NULL)              0,1
ac_flip         (pimage, axis, NULL)            0,1
ac_resize       (pimage, dimx, dimy)            0,1
ac_findcoordinates (pimage, pparameters, NULL)  0,1
ac_selectpoint  (pimage, x, y)                  0,1
ac_selectrect   (pimage, prect, NULL)           0,1
ac_centeratlas  (ra*1E6, dec*1E6, showAtlas)    1
*)


function pi_initialize(funcaddress:pointer; menuname,description:PAnsiChar;
         whandle: HWND):integer; stdcall;
begin
   callback := funcaddress;
   strcopy(menuname,'Delphi form demo');
   strcopy(description,'An example of form creation with Delphi');
   Form1 := nil;
   result := 1;
end;

procedure pi_activate(pimage:pointer; whandle:HWND); stdcall;
begin
   if Form1 = nil then begin
      Form1 := TForm1.Create(Application);
   end;
   Form1.Show;
end;

procedure pi_finalize(whandle:HWND); stdcall;
begin
   if Form1 <> nil then
      Form1.Release;
end;

end.

